done :: IO()
done = return() 

write :: String -> IO()
write [] = done
write (c:cs) = putChar c >> write cs

write2 :: String -> IO()
write2 = foldr (>>) done . (map putChar)

writeln :: String ->IO()
writeln cs = write2 cs >> putChar '\n'

readn :: Int -> IO String
readn 0 = return []
readn (n+1) = getChar >>= q
    where q c = readn n >>= r
	      where r cs = return (c:cs)

readln :: IO String
readln = getChar >>= q
    where q c = if c =='\n'
		then return []
		else readln >>= r
		    where r cs = return (c:cs)

readnDo :: Int -> IO String
readnDo 0 = return []
readnDo (n+1) = do c <- getChar
		   cs <- readnDo n
		   return (c:cs)

readlnDo :: IO String
readlnDo = do c <- getChar
	      if c =='\n'
		then return []
		else do cs <- readln
			return (c:cs)


putN :: Int ->IO()
putN n = do s <- readn n
	    write2 s

-- palindrom Beispiel

isLetter :: Char -> Bool
isLetter c
    | c>='a' && c<='z' ||c>='A' && c<='Z' = True
    |otherwise= False

palindrome :: IO()
palindrome = do write "Einen String eingeben: "
		cs <- getLine
		if palin cs
		   then writeln "YES"
		   else writeln "NO"

palin :: String -> Bool
palin xs = (ys == reverse ys)
	   where ys = map toUpper(filter isLetter xs)